function varargout = tracker(varargin)
% TRACKER M-file for tracker.fig
%      TRACKER, by itself, creates a new TRACKER or raises the existing
%      singleton*.
%
%      H = TRACKER returns the handle to a new TRACKER or the handle to
%      the existing singleton*.
%
%      TRACKER('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in TRACKER.M with the given input arguments.
%
%      TRACKER('Property','Value',...) creates a new TRACKER or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before tracker_OpeningFcn gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to tracker_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help tracker

% Last Modified by GUIDE v2.5 23-May-2008 18:20:27

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @tracker_OpeningFcn, ...
                   'gui_OutputFcn',  @tracker_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before tracker is made visible.
function tracker_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to tracker (see VARARGIN)

% Choose default command line output for tracker
handles.output = hObject;
handles.filename = 'none';
% Update handles structure
guidata(hObject, handles);

% UIWAIT makes tracker wait for user response (see UIRESUME)
% uiwait(handles.figure1);
clearAllAxes(handles);


% --- Outputs from this function are returned to the command line.
function varargout = tracker_OutputFcn(hObject, eventdata, handles) 
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;


% --- Executes on button press in start.
function start_Callback(hObject, eventdata, handles)
% hObject    handle to start (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
clearAllAxes(handles);
handles.trackingRunning = 1;
guidata(hObject, handles);

% Get parameters from GUI
contents = get(handles.binsHist,'String');
binsHist = str2num(contents{get(handles.binsHist,'Value')});
contents = get(handles.binsCooc,'String');
binsCooc = str2num(contents{get(handles.binsCooc,'Value')});





if(strcmp(handles.filename,'none')) %if file is not ope, then open a file
    open_Callback(hObject, eventdata, handles);
    handles = guidata(hObject);
end

h = howManyTrackers; %open selection box
waitfor(h);
nTrackers = getappdata(0,'nTrackers');
s = struct('id', cell(1,nTrackers)); %define tracker struct




set(gcf,'CurrentAxes',handles.axes2);
if(strcmp(handles.type,'movie'))
    im = read(handles.movObj, 1);
    im = im(1:2:size(im,1),:,:);
else
    im = imread(fullfile(handles.pathname,handles.imgFiles(1).name));
end
if (get(handles.useGray,'Value'))
    im = rgb2gray(im);
    if (get(handles.histEq,'Value'))
        im = histeq(im);
    end
elseif (get(handles.histEq,'Value'))
    req = histeq(im(:,:,1));
    beq = histeq(im(:,:,3));
    geq = histeq(im(:,:,2));
    im = cat(3,req,geq,beq);
end
imshow(im);
drawnow;
set(handles.text1,'String','Select global area');
set(handles.text1,'FontSize',15);
k = waitforbuttonpress; %#ok<NASGU>
point1 = get(gca,'CurrentPoint');   % button down detected
finalRect = rbbox;                  %#ok<NASGU> % return figure units
point2 = get(gca,'CurrentPoint');   % button up detected
[rows, cols] = size(im);
max_c = max([point1(1,1),point2(1,1)]);
min_c = min([point1(1,1),point2(1,1)]);
max_r = max([point1(1,2),point2(1,2)]);
min_r = min([point1(1,2),point2(1,2)]);
crop = [max([1,min_r]) min([max_r,rows]) max([1,min_c]) min([cols,max_c])];
crop = uint16(crop);
if(get(handles.template,'Value'))
    load crop.mat;
end
for i=1:nTrackers
    s(i).binsHist = binsHist;
    s(i).binsCooc = binsCooc;
    s(i).spatLim = 9/10;% local maximum must be higher than spatLim of global maximum
    s(i).crop = uint16(crop);
end
save('crop.mat','crop');

if(get(handles.saveVid,'Value'))
    saveDir = datestr(now, 'yyyy-mm-dd_HH-MM');
    mkdir(saveDir);
    mov = avifile([saveDir , '/' , datestr(now, 'yyyy-mm-dd_HH-MM-SS.avi')],'fps',50, 'quality',100);
elseif (get(handles.saveComp,'Value'))
    saveDir = datestr(now, 'yyyy-mm-dd_HH-MM');
    mkdir(saveDir);
end
if(get(handles.saveVid,'Value'))
    save([saveDir,'/crop.mat'],'crop');
end



startFrame = 1;
if(get(handles.sladd,'Value'))
    set(gcf,'windowbuttonmotionfcn',@hover);
    set(gcf,'keypressfcn',@key);
    setappdata(gcf,'sladd_dx',30);
    setappdata(gcf,'sladd_dy',30);
end
f = struct('id', cell(1,handles.frames)); %define position struct
for i=startFrame:1:handles.frames
    tic
    handles = guidata(hObject);
    if handles.trackingRunning == 0 %user click stop
        handles = resertMethodStrings(handles);
        if(get(handles.saveVid,'Value'))
            mov = close(mov); %#ok<NASGU>
            save([saveDir,'/positions.mat'],'f');
        end
        guidata(hObject, handles);
        return
    end

    if(strcmp(handles.type,'movie'))
        im = read(handles.movObj, i);
        im = im(1:2:size(im,1),:,:);
    else
        im = imread(fullfile(handles.pathname,handles.imgFiles(i).name));
    end
    im = im(crop(1):crop(2),crop(3):crop(4),:); %global crop
    
    if (get(handles.useGray,'Value'))
        im = rgb2gray(im);
        if (get(handles.histEq,'Value'))
            im = histeq(im);
        end
    elseif (get(handles.histEq,'Value'))
        im = rgbHistEq(im);
    end
    
    
    set(gcf,'CurrentAxes',handles.axes2);
    handles = clearAllAxes2(handles);
    
    if(get(handles.sladd,'Value'))
        sladd_y=getappdata(gcf,'sladd_y');
        sladd_x=getappdata(gcf,'sladd_x');
        sladd_dy = getappdata(gcf,'sladd_dy');
        sladd_dx = getappdata(gcf,'sladd_dx');
        imSladd = im;
        if(i==startFrame)
            imSladd(:,:,:)=0;
        else
            imSladd(sladd_y-sladd_dy:sladd_y+sladd_dy,sladd_x-sladd_dx:sladd_x+sladd_dx,:)=0;
        end
        imshow(imSladd);
    else
        imshow(im);
    end
    hold on;
    
    if(get(handles.skinDetector,'Value'))
        if(i==startFrame)
            [red,green] = getSkinColor(im,handles);
        end
        s.skin = detectSkin(im, [min(red) max(red)], [min(green) max(green)]);
        skin2(:,:,1)=s.skin;
        skin2(:,:,2)=s.skin;
        skin2(:,:,3)=s.skin;
        imshow(uint8(double(im).*skin2))
    end

    if ( i==startFrame)
        maxmin = zeros(nTrackers,4,11);
        for j=1:nTrackers
            [s(j).imgRows, s(j).imgCols, s(j).imgDim] = size(im); %#ok<NASGU>
            set(handles.text1,'String',['Select area nr' num2str(j)]);
            set(handles.text1,'FontSize',15);
            if(get(handles.template,'Value'))
                load max_min_r_c.mat;
                min_r = maxmin(j,1,1); max_r= maxmin(j,2,1); min_c= maxmin(j,3,1); max_c= maxmin(j,4,1);
            else
                k = waitforbuttonpress; %#ok<NASGU>
                point1 = get(gca,'CurrentPoint');   % button down detected
                finalRect = rbbox;                  %#ok<NASGU> % return figure units
                point2 = get(gca,'CurrentPoint');   % button up detected
                max_c = uint16(max([point1(1,1),point2(1,1)]));
                min_c = uint16(min([point1(1,1),point2(1,1)]));
                max_r = uint16(max([point1(1,2),point2(1,2)]));
                min_r = uint16(min([point1(1,2),point2(1,2)]));
            end
            maxmin(j,:,1) = [min_r,max_r,min_c,max_c];
            s = makeModels(s,j,im,min_r,max_r,min_c,max_c);
            
            set(gcf,'CurrentAxes',handles.axes1);
            imshow(s(j).im2);
            
            
            if(get(handles.startupModels,'Value'))
                set(gcf,'CurrentAxes',handles.axes2);
                handles.im = im;
                guidata(hObject, handles);
                set(gcf,'windowbuttonmotionfcn',@hover);
                box_dx = max_c-min_c;
                box_dy = max_r-min_r;
                setappdata(gcf,'box_dx',box_dx);
                setappdata(gcf,'box_dy',box_dy);
                saveModCnt = 1;
                for model=10:floor(handles.frames/10):handles.frames
                    saveModCnt = saveModCnt +1;
                    if model==10
                        imNewMod = imread(fullfile(handles.pathname,handles.imgFiles(28).name));
                    else
                        imNewMod = imread(fullfile(handles.pathname,handles.imgFiles(model).name));
                    end
                    
                    imNewMod = imNewMod(crop(1):crop(2),crop(3):crop(4),:); %global crop
                    if (get(handles.histEq,'Value'))
                        imNewMod = rgbHistEq(imNewMod);
                    end
                    imshow(imNewMod);
                    handles.im = imNewMod;
                    guidata(hObject, handles);
                    for j=1:nTrackers
                        set(handles.text1,'String',['Frame ' num2str(model) ': Select area nr' num2str(j)]);
                        set(handles.text1,'FontSize',15);
                                          
                        if(get(handles.template,'Value'))
                            load max_min_r_c.mat;
                            min_r = maxmin(j,1,saveModCnt); max_r= maxmin(j,2,saveModCnt); min_c= maxmin(j,3,saveModCnt); max_c= maxmin(j,4,saveModCnt);
                        else
                            k = waitforbuttonpress;
                            box_x = getappdata(gcf,'box_x');
                            box_y = getappdata(gcf,'box_y');
                            min_c = uint16(box_x);
                            max_c = min_c + box_dx;
                            min_r = uint16(box_y);
                            max_r = min_r + box_dy;
                        end
                        maxmin(j,:,saveModCnt) = [min_r,max_r,min_c,max_c];

                        s(j).im2 = imNewMod(min_r:max_r,min_c:max_c,:);
                        s(j).imgCmp(end+1).im = s(j).im2;
                        s(j).hist1(end+1).hist = getHistogram(double(s(j).im2), binsHist);
                        [s(j).h1(end+1).h,s(j).mu1(end+1).mu,s(j).sigma1(end+1).sigma] = getSpatiogram(double(s(j).im2), binsHist);
                        coocIm = bitshift(s(j).im2,-log(256/binsCooc)/log(2));
                        coocIm = coocIm + 1;
                        s(j).cooc1(end+1).cooc = getCoocMatrix(double(coocIm), binsCooc);
                    end
                    %end add model
                end
                set(gcf,'windowbuttonmotionfcn','');
                imshow(im);
            end
            
            
        end
        save('max_min_r_c.mat','maxmin');
        if(get(handles.saveVid,'Value'))
            save([saveDir,'/max_min_r_c.mat'],'maxmin');
        end
    end
    
    if (get(handles.enableMotionDetection,'Value'))
        if i==startFrame
            imPrev = im;
        else
            s.imMotion = uint8(abs(double(im)-double(imPrev))*3);
            imwrite(s.imMotion,['motion_',sprintf('%04.0f',i),'.jpg'],'jpg')
            imPrev = im;
            set(gcf,'CurrentAxes',handles.axes2);
            imshow(s.imMotion);
        end
    end

    for j=1:nTrackers

        s(j).filemane = fullfile(handles.pathname,handles.imgFiles(i).name);
        s(j).globalCrop = crop;
        if(get(handles.enableCircleHist,'Value'))
            
            [imgRows, imgCols, imgDim] = size(im);
            box = [s(j).circleHistBox(2,1)-s(j).circleHistBox(1,1)+1 , s(j).circleHistBox(2,2)-s(j).circleHistBox(1,2)+1];
            s(j).circleHistSubCord = [ max([1 , s(j).circleHistBox(1,1) - box(1)]) , max([1 , s(j).circleHistBox(1,2) - box(2)]); min([imgRows , s(j).circleHistBox(2,1) + box(1)]) , min([imgCols , s(j).circleHistBox(2,2) + box(2)])];
            subIm = im(s(j).circleHistSubCord(1,1):s(j).circleHistSubCord(2,1),s(j).circleHistSubCord(1,2):s(j).circleHistSubCord(2,2),:);

            [s(j).circleHistBox, s(j).score,s(j).zCircleHist] = bestImCircleFit(subIm,box,s(j).circleHistLabel, s(j).circleHistRef);
            
            s(j).circleHistBox = s(j).circleHistBox + [s(j).circleHistSubCord(1,:);s(j).circleHistSubCord(1,:)] - 1;
            s(j).circleHistCenter = [(double(s(j).circleHistBox(1,1)) + (double(s(j).circleHistBox(2,1)) - double(s(j).circleHistBox(1,1)))/2) , (double(s(j).circleHistBox(1,2)) + (double(s(j).circleHistBox(2,2)) - double(s(j).circleHistBox(1,2)))/2) ];
            
%             z=flipud(s(j).zCircleHist);
%             [xInd yInd] = localMaximum(z,[5 5]);
%             [yInd xInd] = removeLowValues(z, xInd, yInd,15/16);
%             s(j).yIndCircleHist = double(s(j).circleHistSubCord(1,1)) + size(z,1) -1 - yInd + double(s(j).circleHistBox(2,1) - s(j).circleHistBox(1,1)+1)/2;
%             s(j).xIndCircleHist = xInd + double(s(j).circleHistSubCord(1,2)) -1 + double(s(j).circleHistBox(2,2) - s(j).circleHistBox(1,2)+1)/2;
%             s(j).yIndCircleHist = s(j).yIndCircleHist';
%             s(j).xIndCircleHist = s(j).xIndCircleHist';
        end
        if(get(handles.spatEnable,'Value'))

            %get parameters from GUI
            contents = get(handles.px,'String');
            px = str2num(contents{get(handles.px,'Value')});
            contents = get(handles.py,'String');
            py = str2num(contents{get(handles.py,'Value')});
            contents = get(handles.resTrackSpat,'String');
            resTrackSpat = str2num(contents{get(handles.resTrackSpat,'Value')});
            
            
            if(get(handles.spatV2,'Value'))
                if(mod(i,1)==0)
                    px=3;
                    py=2;
                    resTrackSpat=6;
                end
            end
            
            s = getBestSpatMatch(s,j,i,im,px,py,resTrackSpat);
            
            if(get(handles.enableEdge,'Value'))
                subIm = im(s(j).spatSubCord(1,1):s(j).spatSubCord(2,1),s(j).spatSubCord(1,2):s(j).spatSubCord(2,2),:);
                BW = edge(rgb2gray(subIm),'canny',.5);
                L = bwlabel(BW,8);
                a = reshape(L,size(BW,1)*size(BW,2),1);
                n = hist(a,max(a));
                n2 = sort(n);
                if(numel(n2)>1)
                    beste = n2(end-1);
                    ind = find(n==beste);
                    BW3 = zeros(size(BW,1),size(BW,2));
                    BW3(L==ind(1))=1;
    %                 clear BW2;
                    BW=BW3;
                end
                BW2 = BW;
                BW2(:,:,1) = BW;
                BW2(:,:,2) = BW;
                BW2(:,:,3) = BW;
                BW2 = uint8(BW2);
                BW2(BW2 == 1) = 255;
                set(gcf,'CurrentAxes',handles.axes3);
                s(j).edgeIm = subIm + BW2;
                imshow(s(j).edgeIm); 
                set(gcf,'CurrentAxes',handles.axes2);
            end         
        end
        if(get(handles.histEnable,'Value'))
            %get parameters from GUI
            contents = get(handles.px,'String');
            px = str2num(contents{get(handles.px,'Value')});
            contents = get(handles.py,'String');
            py = str2num(contents{get(handles.py,'Value')});
            
            s = getBestHistMatch(s,j,im,px,py);
        end
        
        if(get(handles.coocEnable,'Value'))
            %get parameters from GUI
            contents = get(handles.px,'String');
            px = str2num(contents{get(handles.px,'Value')});
            contents = get(handles.py,'String');
            py = str2num(contents{get(handles.py,'Value')});
            contents = get(handles.resTrack,'String');
            resTrack = str2num(contents{get(handles.resTrack,'Value')});
            
%             if(i>startFrame && (s(j).CoocCenter(2)<size(im,2)/2 || (sqrt(sum(((s(j).CoocCenter-s(j).SpatCenter).^2),2))>25)))
%                 px=4;
%                 py=1.5;
%                 s(j).coocModelInUse = s(j).spatModelInUse;
%                 set(handles.enableAdjustment,'Value',1)
%             else
%                 set(handles.enableAdjustment,'Value',0)
%             end
            
            s = getBestCoocMatch(s,j,i,im,px,py,resTrack);
            
            if(get(handles.coocUpdate,'Value'))
                if(s(j).score > get(handles.coocUpdateSlider,'Value'))
                    s(j).cooc1 = s(j).cooc1 + s(j).cooc2;
                    set(handles.coocUpdate,'String','Use cooc model update UPDATED');
                else
                    set(handles.coocUpdate,'String','Use cooc model update');
                end
            else
                set(handles.coocUpdate,'String','Use cooc model update');
            end            
        end
        if(get(handles.enableImgCmp,'Value'))
            %get parameters from GUI
            contents = get(handles.px,'String');
            px = str2num(contents{get(handles.px,'Value')});
            contents = get(handles.py,'String');
            py = str2num(contents{get(handles.py,'Value')});
            
            s = getBestAngleMatch(s,j,i,im,px,py,startFrame,handles);

        end
                

        s(j).indMax = 1;
        if(get(handles.enableAdjustment,'Value'))    
            [s] = getBestPositionCombination(s,j,handles);
        end
        


        if(get(handles.histEnable,'Value'))
            [s,f,handles] = plotHistResult(s,f,j,i,handles);
        end
        if(get(handles.spatEnable,'Value'))
            [s,f,handles] = plotSpatResult(s,f,j,i,handles);
        end
        if(get(handles.coocEnable,'Value'))  
            [s,f,handles] = plotCoocResult(s,f,j,i,handles);
        end
        if(get(handles.enableImgCmp,'Value'))
            [s,f,handles] = plotImgCmpResult(s,f,j,i,handles);
        end
        if(get(handles.enableCircleHist,'Value'))       
            [s,f,handles] = plotCircleHistResult(s,f,j,i,handles);
        end
        
    end
    
    set(gcf,'CurrentAxes',handles.axes1);
    imshow(s(1).imgCmp(1).im);
    title('Model currently in use');
    
    set(gcf,'CurrentAxes',handles.axes2);
	set(handles.text1,'FontSize',15);
    set(handles.text1,'String',['Co-oc model: ' num2str(s(1).coocModelInUse) ', spat model: ' num2str(s(1).spatModelInUse) ]);

    delay = get(handles.slider1,'Value');
    set(handles.text2,'String',['Frame delay: ', num2str(delay), ' sec']);
    set(handles.frameNr,'String',['Frame nr: ', num2str(i)]);
    drawnow;
    if(get(handles.saveVid,'Value'))
        frame = getframe(gcf);
        mov = addframe(mov,frame);
        imwrite(frame.cdata,fullfile(saveDir,['frame_',sprintf('%04.0f',i),'.jpg']),'jpg','Quality',100);
    end
    if(get(handles.saveComp,'Value'))
        save([saveDir,'/Frame',num2str(i),'.mat'],'s');
    end
    toc
    pause(delay);
end

set(handles.histEnable,'String','Enable Histogram');
set(handles.spatEnable,'String','Enable Spatiogram');
set(handles.coocEnable,'String','Enable Co-occurrence');
set(handles.enableImgCmp,'String','Enable Angle method');
set(handles.enableCircleHist,'String','Enable Circle Hist');
set(handles.binsHist,'Enable','on');
set(handles.binsCooc,'Enable','on');
set(handles.useGray,'Enable','on');
set(handles.saveVid,'Enable','on');
set(handles.saveComp,'Enable','on');
set(handles.enableAdjustment,'Enable','on');
set(handles.histEq,'Enable','on');
if(get(handles.saveVid,'Value'))
    mov = close(mov); %#ok<NASGU>
    save([saveDir,'/positions.mat'],'f');
end




% --- Executes during object creation, after setting all properties.
function slider1_CreateFcn(hObject, eventdata, handles) %#ok<INUSD,DEFNU>
% hObject    handle to slider1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: slider controls usually have a light gray background.
if isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor',[.9 .9 .9]);
end



% --- Executes on button press in stop.
function stop_Callback(hObject, eventdata, handles) %#ok<INUSL,DEFNU>
% hObject    handle to stop (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
handles.trackingRunning = 0;
handles.markingRunning = 0;
guidata(hObject, handles);
set(handles.histEnable,'String','Enable Histogram');
set(handles.spatEnable,'String','Enable Spatiogram');
set(handles.coocEnable,'String','Enable Co-occurrence');



% --------------------------------------------------------------------
function open_Callback(hObject, eventdata, handles) %#ok<INUSL>
% hObject    handle to open (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
[filename, pathname] = uigetfile( ...
{'*.jpg;*.bmp;*.avi','Video Image files (*.jpg,*.bmp,*.avi)'}, ...
   'Pick a file');
if isequal(filename,0)
   disp('User selected Cancel')
else
   disp(['User selected', fullfile(pathname, filename)])
   handles.pathname = pathname;
   handles.filename = filename;
   if(strfind(filename, '.jpg'))
       handles.type = 'image';
       handles.imgFiles = dir(fullfile(pathname,'*.jpg'));
       handles.frames = length(handles.imgFiles);
       firstFrame = imread(fullfile(pathname, filename));
   elseif(strfind(filename, '.bmp'))
       handles.type = 'image';
       handles.imgFiles = dir(fullfile(pathname,'*.bmp'));
       handles.frames = length(handles.imgFiles);
       firstFrame = imread(fullfile(pathname, filename));
   else
       handles.type = 'movie';
       handles.movObj = mmreader(fullfile(pathname,filename));
       handles.movInfo = mmfileinfo(fullfile(pathname,filename));
       handles.frames = handles.movObj.NumberOfFrames;
       firstFrame = read(handles.movObj, 1);
       firstFrame = firstFrame(1:2:size(firstFrame,1),:,:);
   end
   guidata(hObject, handles);
   set(gcf,'CurrentAxes',handles.axes2);
   imshow(firstFrame);   
end


function [r_c, g_c] = getSkinColor(im,handles)
set(handles.text1,'String','Mark skin region');
set(gcf,'CurrentAxes',handles.axes2);
imshow(im);
r_c = 0; g_c = 0;
for i=1:3
    k = waitforbuttonpress; %#ok<NASGU>
    point1 = get(gca,'CurrentPoint');   % button down detected
    finalRect = rbbox;                  %#ok<NASGU> % return figure units
    point2 = get(gca,'CurrentPoint');   % button up detected
    max_c = max([point1(1,1),point2(1,1)]);
    min_c = min([point1(1,1),point2(1,1)]);
    max_r = max([point1(1,2),point2(1,2)]);
    min_r = min([point1(1,2),point2(1,2)]);
    skinIm = double(im(min_r:max_r,min_c:max_c,:));
    R = skinIm(:,:,1);
    G = skinIm(:,:,2);
    B = skinIm(:,:,3);

    I = R+G+B; 
    I(I==0)=Inf;
    r = R./I;
    g = G./I;
    r_c = [r_c ; reshape(r,size(r,1)*size(r,2),1)]; %#ok<AGROW>
    g_c = [g_c ; reshape(g,size(g,1)*size(g,2),1)]; %#ok<AGROW>
end
r_c = r_c(2:end);g_c=g_c(2:end);
plot(r_c,g_c,'b.');
k = waitforbuttonpress; %#ok<NASGU>



% --- Executes during object creation, after setting all properties.
function binsHist_CreateFcn(hObject, eventdata, handles) %#ok<INUSD,DEFNU>
% hObject    handle to binsHist (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes during object creation, after setting all properties.
function binsCooc_CreateFcn(hObject, eventdata, handles) %#ok<INUSD,DEFNU>
% hObject    handle to binsCooc (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


function clearAllAxes(handles)
cla(handles.axes2);
set(handles.axes1,'Visible','off');
set(handles.axes2,'Visible','off');
set(handles.axes3,'Visible','off');
set(handles.axes4,'Visible','off');
set(handles.axes5,'Visible','off');
set(handles.axes6,'Visible','off');


% --- Executes on slider movement.
function coocUpdateSlider_Callback(hObject, eventdata, handles) %#ok<INUSL,DEFNU>
% hObject    handle to coocUpdateSlider (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'Value') returns position of slider
%        get(hObject,'Min') and get(hObject,'Max') to determine range of slider
set(handles.coocUpdateText,'String',num2str(get(handles.coocUpdateSlider,'Value')));

% --- Executes during object creation, after setting all properties.
function coocUpdateSlider_CreateFcn(hObject, eventdata, handles) %#ok<INUSD,DEFNU>
% hObject    handle to coocUpdateSlider (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: slider controls usually have a light gray background.
if isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor',[.9 .9 .9]);
end


% --- Executes on button press in coocUpdate.
function coocUpdate_Callback(hObject, eventdata, handles) %#ok<INUSL,DEFNU>
% hObject    handle to coocUpdate (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of coocUpdate
set(handles.coocUpdateText,'String',num2str(get(handles.coocUpdateSlider,'Value')));


% --------------------------------------------------------------------
function markRegions_Callback(hObject, eventdata, handles) %#ok<DEFNU>
% hObject    handle to markRegions (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
clearAllAxes(handles);

handles.markingRunning = 1;
guidata(hObject, handles);
if(strcmp(handles.filename,'none'))
    open_Callback(hObject, eventdata, handles);
    handles = guidata(hObject);
end

if(strcmp(handles.type,'movie'))
    im = read(handles.movObj, 1);
    im = im(1:2:size(im,1),:,:);
else
    im = imread(fullfile(handles.pathname,handles.imgFiles(1).name));
end

set(gcf,'CurrentAxes',handles.axes2);
cla(handles.axes2);
imshow(im);

h = howManyTrackers;
waitfor(h);
nTrackers = getappdata(0,'nTrackers');
s = struct('id', cell(1,nTrackers)); %define tracker struct

set(handles.text1,'String','Select global area');
set(handles.text1,'FontSize',15);
k = waitforbuttonpress; %#ok<NASGU>
point1 = get(gca,'CurrentPoint');   % button down detected
finalRect = rbbox;                  %#ok<NASGU> % return figure units
point2 = get(gca,'CurrentPoint');   % button up detected
[rows, cols] = size(im);
max_c = max([point1(1,1),point2(1,1)]);
min_c = min([point1(1,1),point2(1,1)]);
max_r = max([point1(1,2),point2(1,2)]);
min_r = min([point1(1,2),point2(1,2)]);
crop = [max([1,min_r]) min([max_r,rows]) max([1,min_c]) min([cols,max_c])];
crop = uint16(crop);

for i=1:handles.frames
    handles = guidata(hObject);
    if handles.markingRunning == 0
        save([handles.imgFiles(1).name(1:9) , '_pos.mat'],'s');
        clearAllAxes(handles);
        drawnow;
        return
    end
    if(strcmp(handles.type,'movie'))
        im = read(handles.movObj, i);
        im = im(1:2:size(im,1),:,:);
    else
        im = imread(fullfile(handles.pathname,handles.imgFiles(i).name));
    end
    im = im(crop(1):crop(2),crop(3):crop(4),:); %global crop
    set(gcf,'CurrentAxes',handles.axes2);
    cla(handles.axes2);
    imshow(im);
    set(handles.frameNr,'String',['Frame nr: ', num2str(i)]);
    hold on;
    drawnow;
    for j=1:nTrackers
        k = waitforbuttonpress; %#ok<NASGU>
        point = get(gca,'CurrentPoint');   % button down detected
        x = point(1,1);y=point(1,2);
        plot(x,y,'x');
        drawnow;
        s(i).crop = crop;
        s(i).filename = handles.imgFiles(i).name;
        s(i).pos(j).pos = [x+double(crop(3))-1,y+double(crop(1))-1];
        %pause(1);
    end
end
save([handles.imgFiles(1).name(1:9) , '_pos.mat'],'s');
clearAllAxes(handles);
drawnow;



function [label, ref] = makeCircleLabel(im)

[imageSizeY, imageSizeX, dim] = size(im); %#ok<NASGU>
centerX = floor(imageSizeX/2);
centerY = floor(imageSizeY/2);
label = uint8(zeros(imageSizeY,imageSizeX));
[x,y] = meshgrid(1:imageSizeX, 1:imageSizeY);
for r=1:1:min([floor(imageSizeX/2) floor(imageSizeY/2)])
    binaryImage = sqrt((x-centerX).^2 + (y-centerY).^2) <= r;
    label = label + uint8(binaryImage);
end

im = double(im);
radi=zeros(max(max(label)),3);
for i=1:double(max(max(label)))
    [rows,cols] = find(label==i);
    sum=[0 0 0];
    for j=1:length(rows)
        sum = sum + [im(rows(j),cols(j),1) , im(rows(j),cols(j),2) , im(rows(j),cols(j),3)]; 
    end
    sum = sum./length(rows);
    radi(i,:)=sum;
end
ref=flipud(radi);



% --- Executes during object creation, after setting all properties.
function resTrack_CreateFcn(hObject, eventdata, handles) %#ok<INUSD,DEFNU>
% hObject    handle to resTrack (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes during object creation, after setting all properties.
function resTrackSpat_CreateFcn(hObject, eventdata, handles) %#ok<INUSD,DEFNU>
% hObject    handle to resTrackSpat (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



% --- Executes during object creation, after setting all properties.
function px_CreateFcn(hObject, eventdata, handles) %#ok<INUSD,DEFNU>
% hObject    handle to px (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



% --- Executes during object creation, after setting all properties.
function py_CreateFcn(hObject, eventdata, handles) %#ok<INUSD,DEFNU>
% hObject    handle to py (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


function hover(fh,e) %#ok<INUSD>
point = get(gca,'CurrentPoint');
y=ceil(point(1,2));
x=ceil(point(1,1));
setappdata(fh,'sladd_x',x);
setappdata(fh,'sladd_y',y);
setappdata(fh,'box_x',x);
setappdata(fh,'box_y',y);
dx = getappdata(fh,'box_dx');
dy = getappdata(fh,'box_dy');
handles = guidata(fh);
set(gcf,'CurrentAxes',handles.axes2);
imshow(handles.im);
rectangle('Position',[x,y,dx,dy]);
drawnow;

function key(fh,e)
if strcmp(e.Key,'uparrow')
    dy = getappdata(fh,'sladd_dy');
    dy = dy+5;
    setappdata(fh,'sladd_dy',dy);
elseif strcmp(e.Key,'downarrow')
    dy = getappdata(fh,'sladd_dy');
    dy = dy-5;
    setappdata(fh,'sladd_dy',dy);
elseif strcmp(e.Key,'leftarrow')
    dx = getappdata(fh,'sladd_dx');
    dx = dx-5;
    setappdata(fh,'sladd_dx',dx);
elseif strcmp(e.Key,'rightarrow')
    dx = getappdata(fh,'sladd_dx');
    dx = dx+5;
    setappdata(fh,'sladd_dx',dx);
end


        
function handles = resertMethodStrings(handles)
set(handles.histEnable,'String','Enable Histogram');
set(handles.spatEnable,'String','Enable Spatiogram');
set(handles.coocEnable,'String','Enable Co-occurrence');
set(handles.enableImgCmp,'String','Enable Angle method');
set(handles.enableCircleHist,'String','Enable Circle Hist');

function handles = clearAllAxes2(handles)
cla(handles.axes6);
cla(handles.axes5);
cla(handles.axes4);
cla(handles.axes3);
cla(handles.axes2);
cla(handles.axes1);

function s = makeModels(s,j,im,min_r,max_r,min_c,max_c)
s(j).startCoord = [min_r,max_r,min_c,max_c];
s(j).rs=[min_r, max_r];
s(j).cs=[min_c, max_c];
s(j).Histbox = [min_r,min_c;max_r,max_c];
s(j).Spatbox = [min_r,min_c;max_r,max_c];
s(j).Coocbox = [min_r,min_c;max_r,max_c];
s(j).imgCmpBox = [min_r,min_c;max_r,max_c];
s(j).HistCenter = [(max_r-min_r)/2,(max_c-min_c)/2];
s(j).SpatCenter = s(j).HistCenter;
s(j).CoocCenter = s(j).HistCenter;
s(j).imgCmpCenter = s(j).HistCenter;
s(j).spatScore = 1;

s(j).circleHistBox = [min_r,min_c;max_r,max_c];
s(j).rh=uint16(s(j).rs); s(j).ch=uint16(s(j).cs); s(j).rc=uint16(s(j).rs); s(j).cc=uint16(s(j).cs);

s(j).im2 = im(min_r:max_r,min_c:max_c,:);

s(j).imgCmp(1).im = s(j).im2;
[s(j).circleHistLabel, s(j).circleHistRef] = makeCircleLabel(s(j).im2);
[s(j).h1(1).h,s(j).mu1(1).mu,s(j).sigma1(1).sigma] = getSpatiogram(double(s(j).im2), s(j).binsHist);
s(j).spatModelInUse = 1;
s(j).newSpatModFrq = 4;
s(j).coocModelInUse = 1;
s(j).newCoocModFrq = 4;
s(j).imCmpModelInUse = 1;
s(j).newImCmpModFrq = 4;
s(j).hist1(1).hist = getHistogram(double(s(j).im2), s(j).binsHist);
coocIm = bitshift(s(j).im2,-log(256/s(j).binsCooc)/log(2));
coocIm = coocIm + 1;
s(j).cooc1(1).cooc = getCoocMatrix(double(coocIm), s(j).binsCooc);
s(j).cooc1(1).Unfiltred = s(j).cooc1(end).cooc;
h=fspecial('gaussian',3,5);
s(j).cooc1(1).cooc = imfilter(s(j).cooc1(1).cooc,h);



function im = rgbHistEq(im)
req = histeq(im(:,:,1));
beq = histeq(im(:,:,3));
geq = histeq(im(:,:,2));
im = cat(3,req,geq,beq);

function s = getBestHistMatch(s,j,im,px,py)
[imgRows, imgCols, imgDim] = size(im);            
box = [s(j).Histbox(2,1)-s(j).Histbox(1,1)+1 , s(j).Histbox(2,2)-s(j).Histbox(1,2)+1];
s(j).histSubCord = [ max([1 , s(j).Histbox(1,1) - floor(py*box(1))]) , max([1 , s(j).Histbox(1,2) - floor(px*box(2))]); min([imgRows , s(j).Histbox(2,1) + floor(py*box(1))]) , min([imgCols , s(j).Histbox(2,2) + floor(px*box(2))])];
subIm = im(s(j).histSubCord(1,1):s(j).histSubCord(2,1),s(j).histSubCord(1,2):s(j).histSubCord(2,2),:);

[s(j).Histbox, s(j).histScore, s(j).hist2, s(j).zHist] = bestHistFit(subIm,s(j).hist1(1).hist,box,s(j).binsHist);
s(j).Histbox = s(j).Histbox + [s(j).histSubCord(1,:);s(j).histSubCord(1,:)] - 1;
s(j).HistCenter = [(double(s(j).Histbox(1,1)) + (double(s(j).Histbox(2,1)) - double(s(j).Histbox(1,1)))/2) , (double(s(j).Histbox(1,2)) + (double(s(j).Histbox(2,2)) - double(s(j).Histbox(1,2)))/2) ];

z=flipud(s(j).zHist);
[xInd yInd] = localMaximum(z,[5 5]);
[yInd xInd] = removeLowValues(z, xInd, yInd,9/10);
s(j).yIndHist = double(s(j).histSubCord(1,1)) + size(z,1) -1 - yInd + double(s(j).Histbox(2,1) - s(j).Histbox(1,1)+1)/2;
s(j).xIndHist = xInd + double(s(j).histSubCord(1,2)) -1 + double(s(j).Histbox(2,2) - s(j).Histbox(1,2)+1)/2;
s(j).xIndHist = s(j).xIndHist';
s(j).yIndHist = s(j).yIndHist';

function s = getBestSpatMatch(s,j,i,im,px,py,resTrackSpat)
[imgRows, imgCols, imgDim] = size(im);        
box = [s(j).Spatbox(2,1)-s(j).Spatbox(1,1)+1 , s(j).Spatbox(2,2)-s(j).Spatbox(1,2)+1];
s(j).spatSubCord = [ max([1 , s(j).Spatbox(1,1) - floor(py*box(1))]) , max([1 , s(j).Spatbox(1,2) - floor(px*box(2))]); min([imgRows , s(j).Spatbox(2,1) + floor(py*box(1))]) , min([imgCols , s(j).Spatbox(2,2) + floor(px*box(2))])];
subIm = im(s(j).spatSubCord(1,1):s(j).spatSubCord(2,1),s(j).spatSubCord(1,2):s(j).spatSubCord(2,2),:);

[s(j).Spatbox, s(j).spatScore, s(j).h2, s(j).mu2, s(j).sigma2, s(j).zSpat,s(j).spatModelInUse] = bestSpatFit(subIm,s(j).h1,s(j).mu1,s(j).sigma1,box,s(j).binsHist,resTrackSpat,s(j).spatModelInUse,i,s(j).newSpatModFrq);
if(mod(i-1,s(j).newSpatModFrq)==0)
    [s(j).Spatbox, s(j).spatScore, s(j).h2, s(j).mu2, s(j).sigma2, s(j).zSpat,s(j).spatModelInUse] = bestSpatFit(subIm,s(j).h1,s(j).mu1,s(j).sigma1,box,s(j).binsHist,resTrackSpat,s(j).spatModelInUse,i+1,s(j).newSpatModFrq);
end

s(j).Spatbox = s(j).Spatbox + [s(j).spatSubCord(1,:);s(j).spatSubCord(1,:)] - 1;
s(j).SpatCenter = [(double(s(j).Spatbox(1,1)) + (double(s(j).Spatbox(2,1)) - double(s(j).Spatbox(1,1)))/2) , (double(s(j).Spatbox(1,2)) + (double(s(j).Spatbox(2,2)) - double(s(j).Spatbox(1,2)))/2) ];


z=flipud(s(j).zSpat);
[xInd yInd] = localMaximum(z,[5 5]);
[yInd xInd] = removeLowValues(z, xInd, yInd,s(j).spatLim);
s(j).yIndSpat = double(s(j).spatSubCord(1,1)) + size(z,1)*resTrackSpat -1*1 - yInd*resTrackSpat + double(s(j).Spatbox(2,1) - s(j).Spatbox(1,1)+1)/2;
s(j).xIndSpat = xInd*resTrackSpat + double(s(j).spatSubCord(1,2)) -1*resTrackSpat + double(s(j).Spatbox(2,2) - s(j).Spatbox(1,2)+1)/2;
s(j).xIndSpat = s(j).xIndSpat';
s(j).yIndSpat = s(j).yIndSpat';

s(j).xIndSpatRemove = [];
s(j).yIndSpatRemove = [];
if(resTrackSpat==6)
    if(j==2)
        if(numel(s(j).xIndSpat)>1)
            ind = find(s(j).xIndSpat == max(s(j).xIndSpat));
            s(j).xIndSpat(ind) = []; s(j).yIndSpat(ind) = [];
            s(j).xIndSpatRemove = ind; s(j).yIndSpatRemove = ind;
        end
        ind = find(s(j).xIndSpat == min(s(j).xIndSpat));
    else
        if(numel(s(j).xIndSpat)>1)
            ind = find(s(j).xIndSpat == min(s(j).xIndSpat));
            s(j).xIndSpat(ind) = []; s(j).yIndSpat(ind) = [];
            s(j).xIndSpatRemove = ind; s(j).yIndSpatRemove = ind;
        end
        ind = find(s(j).xIndSpat == max(s(j).xIndSpat));
    end
    s(j).SpatCenter = [s(j).yIndSpat(ind) s(j).xIndSpat(ind)];
    s(j).Spatbox = setCenter(s(j).SpatCenter,s(j).Spatbox,imgRows,imgCols);
end


function s = getBestCoocMatch(s,j,i,im,px,py,resTrack)
[imgRows, imgCols, imgDim] = size(im);            
box = [s(j).Coocbox(2,1)-s(j).Coocbox(1,1)+1 , s(j).Coocbox(2,2)-s(j).Coocbox(1,2)+1];
s(j).coocSubCord = [ max([1 , s(j).Coocbox(1,1) - floor(py*box(1))]) , max([1 , s(j).Coocbox(1,2) - floor(px*box(2))]); min([imgRows , s(j).Coocbox(2,1) + floor(py*box(1))]) , min([imgCols , s(j).Coocbox(2,2) + floor(px*box(2))])];
subIm = im(s(j).coocSubCord(1,1):s(j).coocSubCord(2,1),s(j).coocSubCord(1,2):s(j).coocSubCord(2,2),:);
subIm = bitshift(subIm,-log(256/s(j).binsCooc)/log(2));
subIm = subIm + 1;

[s(j).Coocbox, s(j).score,s(j).cooc2,s(j).zCooc,s(j).coocModelInUse] = bestCoocFit(double(subIm),s(j).cooc1,box,s(j).binsCooc,resTrack,s(j).spatModelInUse,i,s(j).newCoocModFrq);
if(mod(i-1,s(j).newCoocModFrq)==0)
    [s(j).Coocbox, s(j).score,s(j).cooc2,s(j).zCooc,s(j).coocModelInUse] = bestCoocFit(double(subIm),s(j).cooc1,box,s(j).binsCooc,resTrack,s(j).spatModelInUse,i+1,s(j).newCoocModFrq);
end

s(j).Coocbox = s(j).Coocbox + [s(j).coocSubCord(1,:);s(j).coocSubCord(1,:)]-1;
s(j).CoocCenter = [(double(s(j).Coocbox(1,1)) + (double(s(j).Coocbox(2,1)) - double(s(j).Coocbox(1,1)))/2) , (double(s(j).Coocbox(1,2)) + (double(s(j).Coocbox(2,2)) - double(s(j).Coocbox(1,2)))/2) ];
disp(s(j).coocModelInUse);

z=flipud(s(j).zCooc);
[xInd yInd] = localMaximum(z,[5 5]);
[yInd xInd] = removeLowValues(z, xInd, yInd,9/10);
s(j).yIndCooc = double(s(j).coocSubCord(1,1)) + size(z,1)*resTrack -1 - yInd*resTrack + double(s(j).Coocbox(2,1) - s(j).Coocbox(1,1)+1)/2;
s(j).xIndCooc = xInd*resTrack + double(s(j).coocSubCord(1,2)) -1 + double(s(j).Coocbox(2,2) - s(j).Coocbox(1,2)+1)/2;
s(j).xIndCooc = s(j).xIndCooc';
s(j).yIndCooc = s(j).yIndCooc';

function s = getBestAngleMatch(s,j,i,im,px,py,startFrame,handles)
[imgRows, imgCols, imgDim] = size(im);            
if(i>startFrame && get(handles.chestTrack,'Value'))
    if(s(j).tackerOnTarget == 0)
        py = 1; px=3;
        box = [s(j).imgCmpBoxBad(2,1)-s(j).imgCmpBoxBad(1,1)+1 , s(j).imgCmpBoxBad(2,2)-s(j).imgCmpBoxBad(1,2)+1];
        s(j).imgSubCord = [ max([1 , s(j).imgCmpBoxBad(1,1) - floor(py*box(1))]) , max([1 , s(j).imgCmpBoxBad(1,2) - floor(px*box(2))]); min([imgRows , s(j).imgCmpBoxBad(2,1) + floor(py*box(1))]) , min([imgCols , s(j).imgCmpBoxBad(2,2) + floor(px*box(2))])];
        subIm = im(s(j).imgSubCord(1,1):s(j).imgSubCord(2,1),s(j).imgSubCord(1,2):s(j).imgSubCord(2,2),:);
        [s(j).imgCmpBox2, s(j).score,s(j).imgCmp2,s(j).zImgCmp] = bestImFit(subIm,s(j).imgCmp,box);
        if(s(j).score>0.992)
            s(j).imgCmpBox = s(j).imgCmpBox2 + [s(j).imgSubCord(1,:);s(j).imgSubCord(1,:)] - 1;
            s(j).imgCmpCenter = [(double(s(j).imgCmpBox(1,1)) + (double(s(j).imgCmpBox(2,1)) - double(s(j).imgCmpBox(1,1)))/2) , (double(s(j).imgCmpBox(1,2)) + (double(s(j).imgCmpBox(2,2)) - double(s(j).imgCmpBox(1,2)))/2) ];
            s(j).tackerOnTarget = 1;
        else
            s(j).imgCmpBox = s(j).imgCmpBox2 + [s(j).imgSubCord(1,:);s(j).imgSubCord(1,:)] - 1;
            s(j).imgCmpCenter = [(double(s(j).imgCmpBox(1,1)) + (double(s(j).imgCmpBox(2,1)) - double(s(j).imgCmpBox(1,1)))/2) , (double(s(j).imgCmpBox(1,2)) + (double(s(j).imgCmpBox(2,2)) - double(s(j).imgCmpBox(1,2)))/2) ];
            s(j).tackerOnTarget = 0;
        end
    else
        box = [s(j).imgCmpBox(2,1)-s(j).imgCmpBox(1,1)+1 , s(j).imgCmpBox(2,2)-s(j).imgCmpBox(1,2)+1];
        s(j).imgSubCord = [ max([1 , s(j).imgCmpBox(1,1) - floor(py*box(1))]) , max([1 , s(j).imgCmpBox(1,2) - floor(px*box(2))]); min([imgRows , s(j).imgCmpBox(2,1) + floor(py*box(1))]) , min([imgCols , s(j).imgCmpBox(2,2) + floor(px*box(2))])];
        subIm = im(s(j).imgSubCord(1,1):s(j).imgSubCord(2,1),s(j).imgSubCord(1,2):s(j).imgSubCord(2,2),:);
        [s(j).imgCmpBox, s(j).score,s(j).imgCmp2,s(j).zImgCmp] = bestImFit(subIm,s(j).imgCmp,box);
        if(s(j).score>0.985)
            s(j).imgCmpBox = s(j).imgCmpBox + [s(j).imgSubCord(1,:);s(j).imgSubCord(1,:)] - 1;
            s(j).imgCmpCenter = [(double(s(j).imgCmpBox(1,1)) + (double(s(j).imgCmpBox(2,1)) - double(s(j).imgCmpBox(1,1)))/2) , (double(s(j).imgCmpBox(1,2)) + (double(s(j).imgCmpBox(2,2)) - double(s(j).imgCmpBox(1,2)))/2) ];
            s(j).tackerOnTarget = 1;
        else
            s(j).imgCmpBox = s(j).imgCmpBox + [s(j).imgSubCord(1,:);s(j).imgSubCord(1,:)] - 1;
            s(j).imgCmpCenter = [(double(s(j).imgCmpBox(1,1)) + (double(s(j).imgCmpBox(2,1)) - double(s(j).imgCmpBox(1,1)))/2) , (double(s(j).imgCmpBox(1,2)) + (double(s(j).imgCmpBox(2,2)) - double(s(j).imgCmpBox(1,2)))/2) ];
            s(j).tackerOnTarget = 0;
            s(j).imgCmpBoxBad = s(j).imgCmpBox;
        end
    end            
else
    box = [s(j).imgCmpBox(2,1)-s(j).imgCmpBox(1,1)+1 , s(j).imgCmpBox(2,2)-s(j).imgCmpBox(1,2)+1];
    s(j).imgSubCord = [ max([1 , s(j).imgCmpBox(1,1) - floor(py*box(1))]) , max([1 , s(j).imgCmpBox(1,2) - floor(px*box(2))]); min([imgRows , s(j).imgCmpBox(2,1) + floor(py*box(1))]) , min([imgCols , s(j).imgCmpBox(2,2) + floor(px*box(2))])];
    subIm = im(s(j).imgSubCord(1,1):s(j).imgSubCord(2,1),s(j).imgSubCord(1,2):s(j).imgSubCord(2,2),:);
    [s(j).imgCmpBox, s(j).score,s(j).imgCmp2,s(j).zImgCmp,s(j).imCmpModelInUse] = bestImFit(subIm,s(j).imgCmp,box,s(j).imCmpModelInUse,i,s(j).newImCmpModFrq);
    s(j).imgCmpBox = s(j).imgCmpBox + [s(j).imgSubCord(1,:);s(j).imgSubCord(1,:)] - 1;
    s(j).imgCmpCenter = [(double(s(j).imgCmpBox(1,1)) + (double(s(j).imgCmpBox(2,1)) - double(s(j).imgCmpBox(1,1)))/2) , (double(s(j).imgCmpBox(1,2)) + (double(s(j).imgCmpBox(2,2)) - double(s(j).imgCmpBox(1,2)))/2) ];
    s(j).tackerOnTarget = 1;
end

z=flipud(s(j).zImgCmp);
[xInd yInd] = localMaximum(z,[5 5]);
[yInd xInd] = removeLowValues(z, xInd, yInd,15/16);
s(j).yIndImgCmp = double(s(j).imgSubCord(1,1)) + size(z,1) -1 - yInd + double(s(j).imgCmpBox(2,1) - s(j).imgCmpBox(1,1)+1)/2;
s(j).xIndImgCmp = xInd + double(s(j).imgSubCord(1,2)) -1 + double(s(j).imgCmpBox(2,2) - s(j).imgCmpBox(1,2)+1)/2;
s(j).yIndImgCmp = s(j).yIndImgCmp';
s(j).xIndImgCmp = s(j).xIndImgCmp';


function [s, indMax] = getBestPositionCombination(s,j,handles)
s(j).indMax = 1;
if(get(handles.enableImgCmp,'Value') && get(handles.spatEnable,'Value') && (get(handles.coocEnable,'Value') == 0))
    s(j).bestIndImgCmp = 1;
    s(j).bestIndSpat = 1;

    [s(j).bestIndImgCmp, s(j).bestIndSpat, dum1, dum2] = bestPerimeter([s(j).xIndImgCmp s(j).yIndImgCmp],[s(j).xIndSpat s(j).yIndSpat],[],[],2); %#ok<NASGU>


    s(j).imgCmpCenter = [s(j).yIndImgCmp(s(j).bestIndImgCmp) s(j).xIndImgCmp(s(j).bestIndImgCmp)];
    s(j).SpatCenter = [s(j).yIndSpat(s(j).bestIndSpat) s(j).xIndSpat(s(j).bestIndSpat)];

    s(j).imgCmpBox = setCenter(s(j).imgCmpCenter,s(j).imgCmpBox,s(j).imgRows,s(j).imgCols);
    s(j).Spatbox = setCenter(s(j).SpatCenter,s(j).Spatbox,s(j).imgRows,s(j).imgCols);
    s(j).indMax = 0;
    
elseif((get(handles.enableImgCmp,'Value')==0) && get(handles.spatEnable,'Value') && get(handles.coocEnable,'Value'))

    s(j).bestIndCooc = 1;
    s(j).bestIndSpat = 1;

    [s(j).bestIndCooc, s(j).bestIndSpat, dum1, dum2] = bestPerimeter([s(j).xIndCooc s(j).yIndCooc],[s(j).xIndSpat s(j).yIndSpat],[],[],2); %#ok<NASGU>

    s(j).CoocCenter = [s(j).yIndCooc(s(j).bestIndCooc) s(j).xIndCooc(s(j).bestIndCooc)];
    s(j).SpatCenter = [s(j).yIndSpat(s(j).bestIndSpat) s(j).xIndSpat(s(j).bestIndSpat)];

    s(j).Coocbox = setCenter(s(j).CoocCenter,s(j).Coocbox,s(j).imgRows,s(j).imgCols);
    s(j).Spatbox = setCenter(s(j).SpatCenter,s(j).Spatbox,s(j).imgRows,s(j).imgCols);
    s(j).indMax = 0;

elseif(get(handles.enableImgCmp,'Value') && get(handles.spatEnable,'Value') && get(handles.coocEnable,'Value') && get(handles.histEnable,'Value'))
    s(j).bestIndCooc = 1;
    s(j).bestIndHist = 1;
    s(j).bestIndSpat = 1;
    s(j).bestIndImgCmp = 1;

    [s(j).bestIndCooc, s(j).bestIndSpat, s(j).bestIndImgCmp,s(j).bestIndHist] = bestPerimeter([s(j).xIndCooc s(j).yIndCooc],[s(j).xIndSpat s(j).yIndSpat],[s(j).xIndImgCmp s(j).yIndImgCmp],[s(j).xIndHist s(j).yIndHist],4);

    s(j).imgCmpCenter = [s(j).yIndImgCmp(s(j).bestIndImgCmp) s(j).xIndImgCmp(s(j).bestIndImgCmp)];
    s(j).CoocCenter = [s(j).yIndCooc(s(j).bestIndCooc) s(j).xIndCooc(s(j).bestIndCooc)];
    s(j).SpatCenter = [s(j).yIndSpat(s(j).bestIndSpat) s(j).xIndSpat(s(j).bestIndSpat)];
    s(j).HistCenter = [s(j).yIndHist(s(j).bestIndHist) s(j).xIndHist(s(j).bestIndHist)];

    s(j).imgCmpBox = setCenter(s(j).imgCmpCenter,s(j).imgCmpBox,s(j).imgRows,s(j).imgCols);
    s(j).Coocbox = setCenter(s(j).CoocCenter,s(j).Coocbox,s(j).imgRows,s(j).imgCols);
    s(j).Spatbox = setCenter(s(j).SpatCenter,s(j).Spatbox,s(j).imgRows,s(j).imgCols);
    s(j).Histbox = setCenter(s(j).HistCenter,s(j).Histbox,s(j).imgRows,s(j).imgCols);
    s(j).indMax = 0;
end

function [s,f,handles] = plotHistResult(s,f,j,i,handles)
set(handles.histEnable,'String','Hist running');
crop = s(j).crop;
set(gcf,'CurrentAxes',handles.axes2);
plot(s(j).HistCenter(2),s(j).HistCenter(1),'xb');
f(i).area(j).histPos = [s(j).HistCenter(2)+double(crop(3))-1,s(j).HistCenter(1)+double(crop(1))-1];

%object box
line([s(j).Histbox(1,2) s(j).Histbox(1,2)], [s(j).Histbox(1,1) s(j).Histbox(2,1)],'Color','b');
line([s(j).Histbox(2,2) s(j).Histbox(2,2)], [s(j).Histbox(1,1) s(j).Histbox(2,1)],'Color','b');
line([s(j).Histbox(1,2) s(j).Histbox(2,2)], [s(j).Histbox(1,1) s(j).Histbox(1,1)],'Color','b');
line([s(j).Histbox(1,2) s(j).Histbox(2,2)], [s(j).Histbox(2,1) s(j).Histbox(2,1)],'Color','b');

%search area box
line([s(j).histSubCord(1,2) s(j).histSubCord(1,2)], [s(j).histSubCord(1,1) s(j).histSubCord(2,1)],'Color','b');
line([s(j).histSubCord(2,2) s(j).histSubCord(2,2)], [s(j).histSubCord(1,1) s(j).histSubCord(2,1)],'Color','b');
line([s(j).histSubCord(1,2) s(j).histSubCord(2,2)], [s(j).histSubCord(1,1) s(j).histSubCord(1,1)],'Color','b');
line([s(j).histSubCord(1,2) s(j).histSubCord(2,2)], [s(j).histSubCord(2,1) s(j).histSubCord(2,1)],'Color','b');

text(double(s(j).histSubCord(1,2) + 4),double(s(j).histSubCord(1,1) + 5),num2str(j),'Color','b');

%contour plot
if (j==1)
    set(gcf,'CurrentAxes',handles.axes6);
    set(handles.axes6,'Visible','on');
    z=flipud(s(j).zHist);
    [xInd yInd] = localMaximum(z,[5 5]);
    [yInd xInd] = removeLowValues(z, xInd, yInd,9/10);
    contourf(z,min(min(z)):(max(max(z)) - min(min(z)))/30 :max(max(z)),'LineStyle','None');
    hold on;
    colormap jet
    axis equal
    maxZ = max(max(z));
    [y,x] = find(z == maxZ);
    plot(xInd, yInd,'x','MarkerSize',8);
    if (s(j).indMax)
        plot(x,y,'x','MarkerSize',12,'LineWidth',2);                
    else
        plot(xInd(s(j).bestIndHist),yInd(s(j).bestIndHist),'x','MarkerSize',12,'LineWidth',2);
    end
    title(['Hist area ' , num2str(j)]);
    xlabel(['Max score: ' , num2str(maxZ)]);
end

function [s,f,handles] = plotSpatResult(s,f,j,i,handles)
crop = s(j).crop;            
set(handles.spatEnable,'String','Spat running');

set(gcf,'CurrentAxes',handles.axes2);
plot(s(j).SpatCenter(2),s(j).SpatCenter(1),'xg');
f(i).area(j).spatPos = [s(j).SpatCenter(2)+double(crop(3))-1,s(j).SpatCenter(1)+double(crop(1))-1];

%object box
line([s(j).Spatbox(1,2) s(j).Spatbox(1,2)], [s(j).Spatbox(1,1) s(j).Spatbox(2,1)],'Color','g');
line([s(j).Spatbox(2,2) s(j).Spatbox(2,2)], [s(j).Spatbox(1,1) s(j).Spatbox(2,1)],'Color','g');
line([s(j).Spatbox(1,2) s(j).Spatbox(2,2)], [s(j).Spatbox(1,1) s(j).Spatbox(1,1)],'Color','g');
line([s(j).Spatbox(1,2) s(j).Spatbox(2,2)], [s(j).Spatbox(2,1) s(j).Spatbox(2,1)],'Color','g');

%search area box
line([s(j).spatSubCord(1,2) s(j).spatSubCord(1,2)], [s(j).spatSubCord(1,1) s(j).spatSubCord(2,1)],'Color','g');
line([s(j).spatSubCord(2,2) s(j).spatSubCord(2,2)], [s(j).spatSubCord(1,1) s(j).spatSubCord(2,1)],'Color','g');
line([s(j).spatSubCord(1,2) s(j).spatSubCord(2,2)], [s(j).spatSubCord(1,1) s(j).spatSubCord(1,1)],'Color','g');
line([s(j).spatSubCord(1,2) s(j).spatSubCord(2,2)], [s(j).spatSubCord(2,1) s(j).spatSubCord(2,1)],'Color','g');

text(double(s(j).spatSubCord(1,2) + 4),double(s(j).spatSubCord(1,1) + 5),num2str(j),'Color','g');

%contour plot
if (j==1)
    set(gcf,'CurrentAxes',handles.axes4);
    cla(handles.axes4);
    reset(handles.axes4);
    set(handles.axes4,'Visible','on');
    z=flipud(s(j).zSpat);
    [xInd yInd] = localMaximum(z,[5 5]);
    [yInd xInd] = removeLowValues(z, xInd, yInd,s(j).spatLim);
    xInd(s(j).xIndSpatRemove) = [];
    yInd(s(j).yIndSpatRemove) = [];
    contourf(z,min(min(z)):(max(max(z)) - min(min(z)))/30 :max(max(z)),'LineStyle','None');
    hold on;
    colormap jet
    axis equal
    maxZ = max(max(z));
    [y,x] = find(z == maxZ);
    plot(xInd, yInd,'x','MarkerSize',8);
    if (s(j).indMax)
        plot(x,y,'x','MarkerSize',12,'LineWidth',2);                
    else
        plot(xInd(s(j).bestIndSpat),yInd(s(j).bestIndSpat),'x','MarkerSize',12,'LineWidth',2);
    end
    title(['Spat area ' , num2str(j)]);
    xlabel(['Max score: ' , num2str(maxZ)]);
elseif j==2
    set(gcf,'CurrentAxes',handles.axes6);
    cla(handles.axes6);
    reset(handles.axes6);
    set(handles.axes6,'Visible','on');
    z=flipud(s(j).zSpat);
    [xInd yInd] = localMaximum(z,[5 5]);
    [yInd xInd] = removeLowValues(z, xInd, yInd,s(j).spatLim);
    xInd(s(j).xIndSpatRemove) = [];
    yInd(s(j).yIndSpatRemove) = [];
    contourf(z,min(min(z)):(max(max(z)) - min(min(z)))/30 :max(max(z)),'LineStyle','None');
    hold on;
    colormap jet
    axis equal
    maxZ = max(max(z));
    [y,x] = find(z == maxZ);
    plot(xInd, yInd,'x','MarkerSize',8);
    if (s(j).indMax)
        plot(x,y,'x','MarkerSize',12,'LineWidth',2);                
    else
        plot(xInd(s(j).bestIndSpat),yInd(s(j).bestIndSpat),'x','MarkerSize',12,'LineWidth',2);
    end
    title(['Spat area ' , num2str(j)]);
    xlabel(['Max score: ' , num2str(maxZ)]);
end

function [s,f,handles] = plotCoocResult(s,f,j,i,handles)
crop = s(j).crop;
set(handles.coocEnable,'String','Co-oc running');

set(gcf,'CurrentAxes',handles.axes2);
plot(s(j).CoocCenter(2),s(j).CoocCenter(1),'xr');
f(i).area(j).coocPos = [s(j).CoocCenter(2)+double(crop(3))-1,s(j).CoocCenter(1)+double(crop(1))-1];

%object box
line([s(j).Coocbox(1,2) s(j).Coocbox(1,2)], [s(j).Coocbox(1,1) s(j).Coocbox(2,1)],'Color','r');
line([s(j).Coocbox(2,2) s(j).Coocbox(2,2)], [s(j).Coocbox(1,1) s(j).Coocbox(2,1)],'Color','r');
line([s(j).Coocbox(1,2) s(j).Coocbox(2,2)], [s(j).Coocbox(1,1) s(j).Coocbox(1,1)],'Color','r');
line([s(j).Coocbox(1,2) s(j).Coocbox(2,2)], [s(j).Coocbox(2,1) s(j).Coocbox(2,1)],'Color','r');

%search area box
line([s(j).coocSubCord(1,2) s(j).coocSubCord(1,2)], [s(j).coocSubCord(1,1) s(j).coocSubCord(2,1)],'Color','r');
line([s(j).coocSubCord(2,2) s(j).coocSubCord(2,2)], [s(j).coocSubCord(1,1) s(j).coocSubCord(2,1)],'Color','r');
line([s(j).coocSubCord(1,2) s(j).coocSubCord(2,2)], [s(j).coocSubCord(1,1) s(j).coocSubCord(1,1)],'Color','r');
line([s(j).coocSubCord(1,2) s(j).coocSubCord(2,2)], [s(j).coocSubCord(2,1) s(j).coocSubCord(2,1)],'Color','r');

text(double(s(j).coocSubCord(1,2) + 4),double(s(j).coocSubCord(1,1) + 5),num2str(j),'Color','r');


%contour plot
if (j==1)
    set(gcf,'CurrentAxes',handles.axes3);
    cla(handles.axes3);
    reset(handles.axes3);
    set(handles.axes3,'Visible','on');
    z=flipud(s(j).zCooc);
    [xInd yInd] = localMaximum(z,[5 5]);
    [yInd xInd] = removeLowValues(z, xInd, yInd,9/10);
    contourf(z,min(min(z)):(max(max(z)) - min(min(z)))/30 :max(max(z)),'LineStyle','None'); 
    hold on;
    colormap jet
    axis equal
    maxZ = max(max(z));
    [y,x] = find(z == maxZ);
    plot(xInd, yInd,'x','MarkerSize',8);
    if (s(j).indMax)
        plot(x,y,'x','MarkerSize',12,'LineWidth',2);                
    else
        plot(xInd(s(j).bestIndCooc),yInd(s(j).bestIndCooc),'x','MarkerSize',12,'LineWidth',2);
    end
    title(['Cooc area ' , num2str(j)]);
    xlabel(['Max score: ' , num2str(maxZ)]);

elseif j==2
    set(gcf,'CurrentAxes',handles.axes5);
    set(handles.axes5,'Visible','on');
    z=flipud(s(j).zCooc);
    [xInd yInd] = localMaximum(z,[5 5]);
    [yInd xInd] = removeLowValues(z, xInd, yInd,9/10);
    contourf(z,min(min(z)):(max(max(z)) - min(min(z)))/30 :max(max(z)),'LineStyle','None');
    hold on;
    colormap jet
    axis equal
    maxZ = max(max(z));
    [y,x] = find(z == maxZ);
    plot(xInd, yInd,'x','MarkerSize',8);
    if (s(j).indMax)
        plot(x,y,'x','MarkerSize',12,'LineWidth',2);                
    else
        plot(xInd(s(j).bestIndCooc),yInd(s(j).bestIndCooc),'x','MarkerSize',12,'LineWidth',2);
    end
    title(['Cooc area ' , num2str(j)]);
    xlabel(['Max score: ' , num2str(maxZ)]);
end

function [s,f,handles] = plotImgCmpResult(s,f,j,i,handles)
crop = s(j).crop;            
set(handles.enableImgCmp,'String','Img cmp running');

set(gcf,'CurrentAxes',handles.axes2);
plot(s(j).imgCmpCenter(2),s(j).imgCmpCenter(1),'xy');

f(i).area(j).imCmpPos = [s(j).imgCmpCenter(2)+double(crop(3))-1,s(j).imgCmpCenter(1)+double(crop(1))-1];

%object box
line([s(j).imgCmpBox(1,2) s(j).imgCmpBox(1,2)], [s(j).imgCmpBox(1,1) s(j).imgCmpBox(2,1)],'Color','y');
line([s(j).imgCmpBox(2,2) s(j).imgCmpBox(2,2)], [s(j).imgCmpBox(1,1) s(j).imgCmpBox(2,1)],'Color','y');
line([s(j).imgCmpBox(1,2) s(j).imgCmpBox(2,2)], [s(j).imgCmpBox(1,1) s(j).imgCmpBox(1,1)],'Color','y');
line([s(j).imgCmpBox(1,2) s(j).imgCmpBox(2,2)], [s(j).imgCmpBox(2,1) s(j).imgCmpBox(2,1)],'Color','y');

%search area box
line([s(j).imgSubCord(1,2) s(j).imgSubCord(1,2)], [s(j).imgSubCord(1,1) s(j).imgSubCord(2,1)],'Color','y');
line([s(j).imgSubCord(2,2) s(j).imgSubCord(2,2)], [s(j).imgSubCord(1,1) s(j).imgSubCord(2,1)],'Color','y');
line([s(j).imgSubCord(1,2) s(j).imgSubCord(2,2)], [s(j).imgSubCord(1,1) s(j).imgSubCord(1,1)],'Color','y');
line([s(j).imgSubCord(1,2) s(j).imgSubCord(2,2)], [s(j).imgSubCord(2,1) s(j).imgSubCord(2,1)],'Color','y');

text(double(s(j).imgSubCord(1,2) + 4),double(s(j).imgSubCord(1,1) + 5),num2str(j),'Color','y');


%contour plot
if (j==1)
    set(gcf,'CurrentAxes',handles.axes5);
    cla(handles.axes5);
    reset(handles.axes5);
    set(handles.axes5,'Visible','on');
    z=flipud(s(j).zImgCmp);
    [xInd yInd] = localMaximum(z,[5 5]);
    [yInd xInd] = removeLowValues(z, xInd, yInd,15/16);
    contourf(z,min(min(z)):(max(max(z)) - min(min(z)))/30 :max(max(z)),'LineStyle','None');
    hold on;
    colormap jet
    axis equal
    maxZ = max(max(z));
    [y,x] = find(z == maxZ);
    plot(xInd, yInd,'x','MarkerSize',8);
    if (s(j).indMax)
        plot(x,y,'x','MarkerSize',12,'LineWidth',2);                
    else
        plot(xInd(s(j).bestIndImgCmp),yInd(s(j).bestIndImgCmp),'x','MarkerSize',12,'LineWidth',2);
    end
    title(['Angle area ' , num2str(j)]);
    xlabel(['Max score: ' , num2str(maxZ)]);
end
if (j==2)
    set(gcf,'CurrentAxes',handles.axes5);
    set(handles.axes5,'Visible','on');
    z=flipud(s(j).zImgCmp);
    [xInd yInd] = localMaximum(z,[5 5]);
    [yInd xInd] = removeLowValues(z, xInd, yInd,15/16);
    contourf(z,min(min(z)):(max(max(z)) - min(min(z)))/30 :max(max(z)),'LineStyle','None');
    hold on;
    colormap jet
    axis equal
    maxZ = max(max(z));
    [y,x] = find(z == maxZ);
    plot(xInd, yInd,'x','MarkerSize',8);
    if (s(j).indMax)
        plot(x,y,'x','MarkerSize',12,'LineWidth',2);                
    else
        plot(xInd(s(j).bestIndImgCmp),yInd(s(j).bestIndImgCmp),'x','MarkerSize',12,'LineWidth',2);
    end
    title(['Img Cmp area ' , num2str(j)]);
    xlabel(['Max score: ' , num2str(maxZ)]);
end

function [s,f,handles] = plotCircleHistResult(s,f,j,i,handles)
crop = s(j).crop;            
set(handles.enableCircleHist,'String','Circle Hist running');

set(gcf,'CurrentAxes',handles.axes2);
plot(s(j).circleHistCenter(2),s(j).circleHistCenter(1),'xw');

f(i).area(j).circleHistPos = [s(j).circleHistCenter(2)+double(crop(3))-1,s(j).circleHistCenter(1)+double(crop(1))-1];

%object box
line([s(j).circleHistBox(1,2) s(j).circleHistBox(1,2)], [s(j).circleHistBox(1,1) s(j).circleHistBox(2,1)],'Color','w');
line([s(j).circleHistBox(2,2) s(j).circleHistBox(2,2)], [s(j).circleHistBox(1,1) s(j).circleHistBox(2,1)],'Color','w');
line([s(j).circleHistBox(1,2) s(j).circleHistBox(2,2)], [s(j).circleHistBox(1,1) s(j).circleHistBox(1,1)],'Color','w');
line([s(j).circleHistBox(1,2) s(j).circleHistBox(2,2)], [s(j).circleHistBox(2,1) s(j).circleHistBox(2,1)],'Color','w');

%search area box
line([s(j).circleHistSubCord(1,2) s(j).circleHistSubCord(1,2)], [s(j).circleHistSubCord(1,1) s(j).circleHistSubCord(2,1)],'Color','w');
line([s(j).circleHistSubCord(2,2) s(j).circleHistSubCord(2,2)], [s(j).circleHistSubCord(1,1) s(j).circleHistSubCord(2,1)],'Color','w');
line([s(j).circleHistSubCord(1,2) s(j).circleHistSubCord(2,2)], [s(j).circleHistSubCord(1,1) s(j).circleHistSubCord(1,1)],'Color','w');
line([s(j).circleHistSubCord(1,2) s(j).circleHistSubCord(2,2)], [s(j).circleHistSubCord(2,1) s(j).circleHistSubCord(2,1)],'Color','w');

text(double(s(j).circleHistSubCord(1,2) + 4),double(s(j).circleHistSubCord(1,1) + 5),num2str(j),'Color','w');


%contour plot
if (j==1)
    set(gcf,'CurrentAxes',handles.axes6);
    set(handles.axes6,'Visible','on');
    z=flipud(s(j).zCircleHist);
    %[xInd yInd] = localMaximum(z,[5 5]);
    %[yInd xInd] = removeLowValues(z, xInd, yInd,10/11);
    contourf(z,min(min(z)):(max(max(z)) - min(min(z)))/30 :max(max(z)),'LineStyle','None');
    hold on;
    colormap jet
    axis equal
    maxZ = max(max(z));
    [y,x] = find(z == maxZ);
    %plot(xInd, yInd,'x','MarkerSize',8);
    if (s(j).indMax)
        plot(x,y,'x','MarkerSize',12,'LineWidth',2);                
    else
        plot(x,y,'x','MarkerSize',12,'LineWidth',2); 
        %plot(xInd(s(j).bestIndImgCmp),yInd(s(j).bestIndImgCmp),'x','MarkerSize',12,'LineWidth',2);
    end
    title(['Circle hist area ' , num2str(j)]);
    xlabel(['Max score: ' , num2str(maxZ)]);
end